const state = {
  paramsSet: {},
  page: {
    current: 1,
    size: 12,
    total: 0,
    totalPage: 1
  },
  steps: {},
  curStep: { name: "", count: 0 },
  areas: [],
  curArea: {},
  curSubject: {},
  ribbonSet: { keyboardMark: false, needEnterSubmit: true },
  curUserRoleType: "",
  IS_MARKER: false,
  IS_MARK_LEADER: false,
  // key shortcut:
  shortcutKeyStatus: {
    page: false,
    action: false,
    preview: false
  }
};
const mutations = {
  setParamSet(state, paramsSet) {
    state.paramsSet = paramsSet;
  },
  setPage(state, page) {
    state.page = Object.assign({}, state.page, page);
  },
  setSteps(state, steps) {
    state.steps = steps;
  },
  setCurStep(state, curStep) {
    state.curStep = curStep;
  },
  setAreas(state, areas) {
    state.areas = areas;
  },
  setCurArea(state, curArea) {
    state.curArea = curArea;
  },
  setCurSubject(state, curSubject) {
    state.curSubject = curSubject;
  },
  setCurUserRoleType(state, curUserRoleType) {
    state.curUserRoleType = curUserRoleType;
    state.IS_MARKER = curUserRoleType === "MARKER";
    state.IS_MARK_LEADER = curUserRoleType === "MARK_LEADER";
  },
  setRibbonSet(state, ribbonSet) {
    state.ribbonSet = ribbonSet;
  },
  setShortcutStatus(state, data) {
    state.shortcutKeyStatus = Object.assign({}, state.shortcutKeyStatus, data);
  },
  setShortcut(state, types) {
    Object.keys(state.shortcutKeyStatus).forEach(key => {
      state.shortcutKeyStatus[key] = types.includes(key);
    });
    // console.log(JSON.stringify(state.shortcutKeyStatus));
  },
  clearState(state) {
    state.paramsSet = {};
    state.page = {
      current: 1,
      size: 12,
      total: 0,
      totalPage: 1
    };
    state.steps = {};
    state.curStep = { name: "", count: 0 };
    state.curArea = {};
    state.curSubject = {};
    state.curUserRoleType = "";
    state.IS_MARKER = false;
    state.IS_MARK_LEADER = false;
    state.shortcutKeyStatus = {
      page: false,
      action: false,
      preview: false
    };
  }
};

export default {
  namespaced: true,
  state,
  mutations
};
